<?php

/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This script defines routines for displaying page revisions.  It
    is included by default from the stdconfig.php script.
*/

SDV($PageDiffFmt,"<h1>\$PageName $[Revisions]</h1>
  <p><a href='\$PageUrl?action=diff&amp;source=y'>Display as markup</a></p>
  ");
SDV($HandleDiffFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "<div id='wikitext'>",&$PageDiffFmt,'function:PrintDiff',"</div>",
  &$PageFooterFmt,&$HTMLEndFmt));
SDV($DiffStartFmt,"
      <div class='diffbox'><div class='difftime'>\$DiffTime</div>");
SDV($DiffDelFmt['a'],"
        <div class='difftype'>\$[Deleted] \$DiffLines:</div>
        <div class='diffdel'>");
SDV($DiffDelFmt['c'],"
        <div class='difftype'>\$[Changed] \$DiffLines \$[from]:</div>
        <div class='diffdel'>");
SDV($DiffAddFmt['d'],"
        <div class='difftype'>\$[Added] \$DiffLines:</div>
        <div class='diffadd'>");
SDV($DiffAddFmt['c'],"</div>
        <div class='difftype'>$[to]:</div>
        <div class='diffadd'>");
SDV($DiffEndDelAddFmt,"</div>");
SDV($DiffEndFmt,"</div>");
SDV($DiffRestoreFmt,"
      <div class='diffrestore'><a href='\$PageUrl?action=edit&amp;restore=\$DiffId&amp;preview=y'>$[Restore]</a></div>");

$HandleActions['diff']='HandleDiff';

function PrintDiff($pagename) {
  global $DiffId,$DiffTime,$TimeFmt,$GCount;
  global $DiffStartFmt,$DiffEndFmt,$DiffAddFmt,$DiffDelFmt,
    $DiffEndDelAddFmt,$DiffRestoreFmt,$SysPatchCmd;
  $page = ReadPage($pagename);
  if (!$page) return;
  Lock(0); 
  krsort($page); reset($page);
  $source = @$_REQUEST['source'];
  foreach($page as $k=>$v) {
    if (!preg_match("/^diff:(\d+):(\d+)/",$k,$match)) continue;
    $DiffId = $k;
    $DiffTime = strftime($TimeFmt,$match[1]); $GCount=0;
    echo FixURIs(FmtPageName($DiffStartFmt,$pagename));
    $difflines = explode("\n",$v."\n");
    $in=array(); $out=array(); $dtype='';
    foreach($difflines as $d) {
      if ($d>'') {
        if ($d[0]=='-' || $d[0]=='\\') continue;
        if ($d[0]=='<') { $out[]=substr($d,2); continue; }
        if ($d[0]=='>') { $in[]=substr($d,2); continue; }
      }
      if (preg_match("/^(\\d+)(,(\\d+))?([adc])\\d/",$dtype,$match)) {
        $clines = ($match[3]>'') ? '$[lines] '.$match[1].'-'.$match[3] :
          '$[line] '.$match[1];
        if ($match[4]=='a' || $match[4]=='c') {
          $txt = str_replace('$DiffLines',$clines,$DiffDelFmt[$match[4]]);
          echo FixURIs(FmtPageName($txt,$pagename));
          if ($source) 
            echo "<code>",
              str_replace("\n","<br />",htmlspecialchars(join("\n",$in))),
              "</code>";
          else PrintText($pagename,join("\n",$in));
        }
        if ($match[4]=='d' || $match[4]=='c') {
          $txt = str_replace('$DiffLines',$clines,$DiffAddFmt[$match[4]]);
          echo FixURIs(FmtPageName($txt,$pagename));
          if ($source) 
            echo "<code>",
              str_replace("\n","<br />",htmlspecialchars(join("\n",$out))),
              "</code>";
          else PrintText($pagename,join("\n",$out));
        }
        echo FixURIs(FmtPageName($DiffEndDelAddFmt,$pagename));
      }
      $in=array(); $out=array(); $dtype=$d;
    }
    echo FixURIs(FmtPageName($DiffEndFmt,$pagename));
    if ($SysPatchCmd) echo FixURIs(FmtPageName($DiffRestoreFmt,$pagename));
  }
}

function HandleDiff($pagename) {
  global $HandleDiffFmt,$HTMLTitle;
  $page = RetrieveAuthPage($pagename,"read");
  if (!$page) { Abort("?cannot diff $pagename"); }
  Lock(0);
  $HTMLTitle = "$pagename Revisions";
  PrintFmt($pagename,$HandleDiffFmt);
}
