<?php
/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This script defines the standard layout scheme used by PmWiki 0.6.
    This is an (X)HTML table-based scheme that makes heavy use of 
    stylesheets for controlling the layout.  To have a completely CSS-based
    layout, see scripts/csslayout.php.

    This script is automatically included by stdconfig.php if the
    $HandleBrowseFmt variable is already defined.
*/

SDV($PageLogoUrlFmt,'$PubDirUrl/pmwiki-32.gif');
$DefaultPageLayout = array(
  'wikihead-c' => "<img src='$PageLogoUrlFmt' alt='' /><br clear='all' />",
  'wikihead-r' => "
    <form action='\$ScriptUrl/$[Main/SearchWiki]'>
      <a href='\$ScriptUrl/$[Main/SearchWiki]'>$[SearchWiki]</a>:
      <input class='searchbox' type='text' name='text' value='' />
      <input class='searchbutton' type='submit' value='$[Go]' /></form>",
  'wikititle-c' => "<div class='pagegroup'><a href='\$ScriptUrl/\$Group'>\$Group</a> /</div>
        <div class='pagetitle'><a href='\$PageUrl?action=search&amp;text=\$Title_'>\$Title</a></div>",
  'wikititle-r' => "
        <a href='\$ScriptUrl/$[\$Group/RecentChanges]'>$[Recent Changes]</a><br />
        <a href='\$PageUrl?action=print'>$[Printable View]</a><br />
        <a href='\$PageUrl?action=diff'>$[Page History]</a><br />
        <a href='\$PageUrl?action=edit'>$[Edit Page]</a><br />",
  'wikifoot-c' => "
    <div class='footnav'>
      <a href='\$PageUrl?action=edit'>$[Edit Page]</a> - 
      <a href='\$PageUrl?action=diff'>$[Page History]</a> -
      <a href='\$ScriptUrl/$[\$Group/RecentChanges]'>$[Recent Changes]</a> - 
      <a href='\$ScriptUrl/$[PmWiki/WikiHelp]'>$[WikiHelp]</a> -
      <a href='\$ScriptUrl/$[Main/SearchWiki]'>$[SearchWiki]</a></div>
    <div class='lastmod'>
      Page last modified on \$LastModified</div>",
);
foreach($DefaultPageLayout as $k=>$v) SDV($PageLayoutFmt[$k],$v);

SDV($PageCSS,array('pub/css/pmwiki.css','pub/css/local.css',
  'pub/css/$Group.css','pub/css/$Group.$Title_.css'));
foreach($PageCSS as $k) {
  $c = FmtPageName($k,$pagename);
  if (file_exists($c)) $HTMLHeaderFmt[] =
    "  <link rel='stylesheet' href='$PmWikiDirUrl/$c' type='text/css' />\n";
}

SDV($PageHeaderFmt,array("
<table id='wikihead' cellspacing='0' cellpadding='0'><tr>
  <td id='wikihead-l'>",&$PageLayoutFmt['wikihead-l'],"</td>
  <td id='wikihead-c'>",&$PageLayoutFmt['wikihead-c'],"</td>
  <td id='wikihead-r'>",&$PageLayoutFmt['wikihead-r'],"</td></tr></table>
<table id='wikimid' cellspacing='0' cellpadding='0'><tr>
  <td id='wikileft' rowspan='2'>",&$PageLayoutFmt['wikileft'],"</td>
  <td></td>
  <td id='wikiright' rowspan='2'>",&$PageLayoutFmt['wikiright'],"</td></tr>
  <tr><td id='wikibody'>"));
SDV($PageFooterFmt,array("</td></tr></table>
<table id='wikifoot' cellspacing='0' cellpadding='0'><tr>
  <td id='wikifoot-l'>",&$PageLayoutFmt['wikifoot-l'],"</td>
  <td id='wikifoot-c'>",&$PageLayoutFmt['wikifoot-c'],"</td>
  <td id='wikifoot-r'>",&$PageLayoutFmt['wikifoot-r'],"</td></tr></table>"));
SDV($PageTitleFmt,array("
    <table id='wikititle' cellspacing='0' cellpadding='0'><tr>
      <td id='wikititle-l'>",&$PageLayoutFmt['wikititle-l'],"</td>
      <td id='wikititle-c'>",&$PageLayoutFmt['wikititle-c'],"</td>
      <td id='wikititle-r'>",&$PageLayoutFmt['wikititle-r'],"</td>
    </tr></table>\n    "));

SDV($PageEditFmt,"<a id='top' name='top'></a><h1>Editing \$PageName</h1>
  <form action='\$ScriptUrl' method='post'>
  <input type='hidden' name='pagename' value='\$PageName' />
  <input type='hidden' name='action' value='edit' />
  <textarea id='wikiedit' name='text' rows='25'
    onkeydown='if (event.keyCode == 27) event.returnValue=false;'
    >\$Text</textarea><br />
  <input type='submit' name='post' value=' $[Save] ' />
  <input type='submit' name='preview' value=' $[Preview] ' />
  <input type='reset' value=' $[Reset] ' />
  </form>");
SDV($PagePreviewFmt,array(
  "function:ProcessTextDirectives",
  "<h2>Preview \$PageName</h2><b>Page is unsaved</b><hr /><p />",
  "function:PrintText",
  "<hr /><b>End of preview -- remember to save</b>
   <br /><a href='#top'>$[Top]</a>"));

SDV($PageAttrFmt,"<h1>$[\$PageName Attributes]</h1>
  <p>Enter new attributes for this page below.  Leaving a field blank
  will leave the attribute unchanged.  To clear an attribute, enter
  'clear'.</p>");

SDV($HandleBrowseFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "<div id='wikitext'>",&$PageRedirectFmt,'function:PrintText','</div>',
  &$PageFooterFmt,&$HTMLEndFmt));
SDV($HandleEditFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "<div id='wikitext'>",&$PageEditFmt,'wiki:$[PmWiki.EditQuickReference',
  &$PagePreviewFmt,'</div>',&$PageFooterFmt,&$HTMLEndFmt));
SDV($HandleAttrFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "<div id='wikitext'>",&$PageAttrFmt,'function:PrintAttrForm','</div>',
  &$PageFooterFmt,&$HTMLEndFmt));
?>
